
/**
 *   : 
 * @author  , '  
 * @version 7/12/2006
 */
public class Circle
{
	private Point center;
	private double radius;
	
	public static final double PI = 3.14;
	
	public Circle(Point center, double radius)
	{
		this.center = new Point(center);
		this.radius = radius;
	}
	
	public Point getCenter()
	{
		return new Point(center);
	}
	
	public double getRadius()
	{
		return radius;
	}
	
	public void setCenter(Point p)
	{
		this.center.setX(p.getX());
		this.center.setY(p.getY());
	}
	
	public void setRadius(double r)
	{
		this.radius = r;
	}
	
	public double calcArea()
	{
		return (Circle.PI*Math.pow(this.radius,2));
	}
	
	public double calcPerimeter()
	{
		return (2*Circle.PI*this.radius);
	}
	
	public boolean circleIsEqual(Circle c1)
	{
		return (this.radius == c1.radius  &&
				this.center.getX() == c1.center.getX() &&
				this.center.getY() == c1.center.getY());
	}
	
	public void circleMove(double dx, double dy)
	{
		center.setX(center.getX() + dx);
		center.setY(center.getY() + dy);
	}
	
	public void circleScale(double k)
	{
		this.radius *= k;
	}
	
	public String toString()
	{
		return "Center: " + center + " Radius: " + radius;
	}
	
	public boolean isInside (Point p)
	{
		double deltaX = p.getX()-center.getX();
		double deltaY = p.getY()-center.getY();
		double distanceFromCenter = Math.sqrt(Math.pow(deltaX,2) + Math.pow(deltaY,2));
		return (distanceFromCenter < this.radius);
	}
}
